﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SharedDataContract;
using System.Threading;

namespace ChatApplication
{
    public class ThreadedCallBack : IDisposable
    {
        private IChatCallback mCallback;

        public  ThreadedCallBack(IChatCallback newcallback)
        {
            mCallback = newcallback;

        }

        #region userenter
        private Person userEnterperson;
        private AsyncCallback  userEntercallback;
        private object userEnterstate;


        public void UserEnter(Person person, AsyncCallback callback, object state)
        {
            userEnterperson = person;
            userEntercallback = callback;
            userEnterstate = state;

            Thread userEnterThread = new Thread(new ThreadStart(DoUserEnter));
            userEnterThread.IsBackground = true;
            userEnterThread.Start();

        }


        private void DoUserEnter()
        {
            try
            {
                mCallback.BeginUserEnter(userEnterperson, userEntercallback, userEnterstate);
            }
            catch
            { }
        
        }
        #endregion userenter

        #region userActive
        private Person userActiveperson;
        private AsyncCallback userActivecallback;
        private object userActivestate;


        public void UserActive(Person person, AsyncCallback callback, object state)
        {
            userActiveperson = person;
            userActivecallback = callback;
            userActivestate = state;

            Thread userActiveThread = new Thread(new ThreadStart(DoUserActive));
            userActiveThread.IsBackground = true;
            userActiveThread.Start();

        }


        private void DoUserActive()
        {
            try
            {
                mCallback.BeginUserActive(userActiveperson, userActivecallback, userActivestate);
            }
            catch
            { }

        }
        #endregion useractive


        #region userDeActive
        private Person userDeActiveperson;
        private AsyncCallback userDeActivecallback;
        private object userDeActivestate;


        public void userDeActive(Person person, AsyncCallback callback, object state)
        {
            userDeActiveperson = person;
            userDeActivecallback = callback;
            userDeActivestate = state;

            Thread userDeActiveThread = new Thread(new ThreadStart(DoUserDeActive));
            userDeActiveThread.IsBackground = true;
            userDeActiveThread.Start();

        }


        private void DoUserDeActive()
        {
            try
            {
                mCallback.BeginUserDeActive(userDeActiveperson, userDeActivecallback, userDeActivestate);
            }
            catch
            { }

        }
        #endregion userDeActive


        #region userWhisper
        private Person userWhisperperson;
        private string userWhispermessage;
        private AsyncCallback userWhispercallback;
        private object userWhisperstate;


        public void userWhisper(Person person ,string message , AsyncCallback callback, object state)
        {
            userWhisperperson = person;
            userWhispercallback = callback;
            userWhisperstate = state;
            userWhispermessage = message;
            Thread userWhisperThread = new Thread(new ThreadStart(DoUserWhisper));
            userWhisperThread.IsBackground = true;
            userWhisperThread.Start();

        }


        private void DoUserWhisper()
        {
            try
            {
                mCallback.BeginWhisperReceive(userWhisperperson,userWhispermessage , userWhispercallback, userWhisperstate);
            }
            catch
            { }

        }
        #endregion userWhisper


        #region userLeave
        private Person userLeaveperson;
        private AsyncCallback userLeavecallback;
        private object userLeavestate;


        public void UserLeave(Person person, AsyncCallback callback, object state)
        {
            userLeaveperson = person;
            userLeavecallback = callback;
            userLeavestate = state;

            Thread userLeaveThread = new Thread(new ThreadStart(DoUserLeave));
            userLeaveThread.IsBackground = true;
            userLeaveThread.Start();

        }


        private void DoUserLeave()
        {
            try
            {
                mCallback.BeginUserLeave(userLeaveperson, userLeavecallback, userLeavestate);
            }
            catch
            { }

        }
        #endregion userenter


        #region userAddUserList
        private Person userAddUserListperson;
        private AsyncCallback userAddUserListcallback;
        private object userAddUserListstate;


        public void UserAddUserList(Person person, AsyncCallback callback, object state)
        {
            userAddUserListperson = person;
            userAddUserListcallback = callback;
            userAddUserListstate = state;

            Thread userAddUserListThread = new Thread(new ThreadStart(DoUserAddUserList));
            userAddUserListThread.IsBackground = true;
            userAddUserListThread.Start();

        }


        private void DoUserAddUserList()
        {
            try
            {
                mCallback.BeginAddUserList(userAddUserListperson, userAddUserListcallback, userAddUserListstate);
            }
            catch
            { }

        }
        #endregion userAddUserList


        #region userVideo
        private Person userVideoperson;
        private AsyncCallback userVideocallback;
        private object userVideostate;
        private VideoFrame frame;

        public void UserVideo(Person person , VideoFrame video, AsyncCallback callback, object state)
        {
            userVideoperson = person;
            userVideocallback = callback;
            userVideostate = state;
            frame = video;
            Thread userVideoThread = new Thread(new ThreadStart(DoUserVideo));
            userVideoThread.IsBackground = true;
            userVideoThread.Start();

        }


        private void DoUserVideo()
        {
            try
            {
                mCallback.BeginReceiveVideo(userVideoperson, frame, userVideocallback, userVideostate);
            }
            catch
            { }

        }
        #endregion userVideo

        #region userTimout
        private Person userTimeout;
        private AsyncCallback userTimeoutcallback;
        private object userTimeoutstate;


        public void UserTimeOut(Person person, AsyncCallback callback, object state)
        {
            userTimeout = person;
            userTimeoutcallback = callback;
            userTimeoutstate = state;
            Thread userTimeoutThread = new Thread(new ThreadStart(DoUserTimeOut));
            userTimeoutThread.IsBackground = true;
            userTimeoutThread.Start();

        }


        private void DoUserTimeOut()
        {
            try
            {
                //mCallback.BeginUserTimOut(userTimeout, userTimeoutcallback, userTimeoutstate);
            }
            catch
            { }

        }
        #endregion userTimout


        #region Dispose

        public void Dispose()
        { 
          
            GC.SuppressFinalize(this);
        
        }



        #endregion

    }
}
