using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.ComponentModel;
using SharedDataContract;
using System.IO;

namespace ChatApplication
{
    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    [ServiceBehavior(AutomaticSessionShutdown = true, AddressFilterMode = AddressFilterMode.Any, MaxItemsInObjectGraph = 2147483647)]
    public class DataService
    {
        private int intCounter;
        [OperationContract]
        [FaultContract(typeof(string))]
        public int Increment1()
        {
            try
            {

                intCounter++;


            }
            catch
            {

                //ChatFaultContract faultDetail = new ChatFaultContract(ex.Message, ex.Message);
                //faultDetail.UserMessage = "Error while getting user list user message.";
                throw new FaultException<string>("faultDetailtest", "Error while getting user list.");


            }
            return intCounter;
        }
        [OperationContract]
        public List<Person> GetPersonList(Person personname)
        {

            SqlConnection connection = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["OnlineChatDatabase"].ConnectionString);
            SqlCommand command = new SqlCommand();
            SqlParameter paramperson = new SqlParameter("@personname", personname.Name);
            command.CommandText = "GetPersonList";
            command.CommandType = CommandType.StoredProcedure;
            command.Connection = connection;
            command.Parameters.Add(paramperson);
            SqlDataAdapter adapter = new SqlDataAdapter(command);
            DataTable dt = new DataTable();
            adapter.Fill(dt);

            return ConvertDataTableToPerson(dt);

        }


        [OperationContract]
        public List<Person> GetActivePersonList(Person personname)
        {

            SqlConnection connection = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["OnlineChatDatabase"].ConnectionString);
            SqlCommand command = new SqlCommand();
            SqlParameter paramperson = new SqlParameter("@personname", personname.Name);
            command.CommandText = "GetActivePersonList";
            command.CommandType = CommandType.StoredProcedure;
            command.Connection = connection;
            command.Parameters.Add(paramperson);
            SqlDataAdapter adapter = new SqlDataAdapter(command);
            DataTable dt = new DataTable();
            adapter.Fill(dt);

            return ConvertDataTableToPerson(dt);

        }


        [OperationContract]
        public void SetDeActivePersonList(Person personname)
        {

            SqlConnection connection = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["OnlineChatDatabase"].ConnectionString);
            SqlCommand command = new SqlCommand();
            SqlParameter paramperson = new SqlParameter("@personname", personname.Name);
            command.CommandText = "SetDeActivePersonList";
            command.CommandType = CommandType.StoredProcedure;
            command.Connection = connection;
            command.Parameters.Add(paramperson);
            SqlDataAdapter adapter = new SqlDataAdapter(command);
            DataTable dt = new DataTable();
            adapter.Fill(dt);

        }


        public void SetUserToUserList(Person personname, Person newpersonname, int Isadded)
        {

            SqlConnection connection = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["OnlineChatDatabase"].ConnectionString);
            SqlCommand command = new SqlCommand();
            SqlParameter paramperson = new SqlParameter("@personname", personname.Name);
            SqlParameter paramnewperson = new SqlParameter("@newpersonname", newpersonname.Name);
            SqlParameter paramIsadded = new SqlParameter("@isadded", SqlDbType.Int, 4);
            paramIsadded.Value = Isadded;

            command.CommandText = "AddUserToUserList";
            command.CommandType = CommandType.StoredProcedure;
            command.Connection = connection;
            command.Parameters.Add(paramperson);
            command.Parameters.Add(paramnewperson);
            command.Parameters.Add(paramIsadded);
            SqlDataAdapter adapter = new SqlDataAdapter(command);
            DataTable dt = new DataTable();
            adapter.Fill(dt);

        }


        [OperationContract]
        public List<UserMessage> GetUserMessages(string personname)
        {

            SqlConnection connection = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["OnlineChatDatabase"].ConnectionString);
            SqlCommand command = new SqlCommand();
            SqlParameter paramperson = new SqlParameter("@personname", personname);
            command.CommandText = "GetUserMessage";
            command.CommandType = CommandType.StoredProcedure;
            command.Connection = connection;
            command.Parameters.Add(paramperson);
            SqlDataAdapter adapter = new SqlDataAdapter(command);
            DataTable dt = new DataTable();
            adapter.Fill(dt);
            return ConvertDataTableToUserMessage(dt);

        }


        [OperationContract]
        public void SetUserMessage(Person personFrom, Person personTo, string subject, string message)
        {

            SqlConnection connection = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["OnlineChatDatabase"].ConnectionString);
            SqlCommand command = new SqlCommand();
            SqlParameter parampersonFrom = new SqlParameter("@personnameFrom", personFrom.Name);
            SqlParameter parampersonTo = new SqlParameter("@personnameTo", personTo.Name);
            SqlParameter paramSubject = new SqlParameter("@subject", subject);
            SqlParameter paramMsg = new SqlParameter("@message", message);
            command.Parameters.Add(parampersonFrom);
            command.Parameters.Add(parampersonTo);
            command.Parameters.Add(paramSubject);
            command.Parameters.Add(paramMsg);

            command.CommandText = "SaveUserMessage";
            command.CommandType = CommandType.StoredProcedure;
            command.Connection = connection;

            SqlDataAdapter adapter = new SqlDataAdapter(command);
            DataTable dt = new DataTable();
            adapter.Fill(dt);

        }

        [OperationContract]
        public List<Person> GetSearchPersonList(string personname, string personfirstname, string personlastname)
        {

            SqlConnection connection = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["OnlineChatDatabase"].ConnectionString);
            SqlCommand command = new SqlCommand();
            SqlParameter paramperson = new SqlParameter("@personname", personname);
            SqlParameter paramfirstperson = new SqlParameter("@personFirstName", personfirstname);

            SqlParameter paramlastperson = new SqlParameter("@personLastName", personlastname);

            command.CommandText = "GetSearchPersonList";
            command.CommandType = CommandType.StoredProcedure;
            command.Connection = connection;
            command.Parameters.Add(paramperson);
            SqlDataAdapter adapter = new SqlDataAdapter(command);
            DataTable dt = new DataTable();
            adapter.Fill(dt);

            return ConvertDataTableToPerson(dt);

        }

        public List<Person> ConvertDataTableToPerson(DataTable dt)
        {
            List<Person> persons = null;
            Person person = null;
            if (dt != null)
            {
                persons = new List<Person>();
                foreach (DataRow dr in dt.Rows)
                {
                    person = new Person();
                    person.Name = dr["User_Name"].ToString();
                    person.IsActive = Convert.ToBoolean(dr["User_Active"]);
                    //person.Person_Id = Convert.ToInt32(dr["User_Id"]);
                    person.ImageURL = dr["Image_Url"].ToString();
                    // person.ImageSource = GetImageStream(dr["Image_Url"].ToString());
                    persons.Add(person);

                }
            }
            return persons;

        }


        public List<UserMessage> ConvertDataTableToUserMessage(DataTable dt)
        {
            List<UserMessage> personmsg = null;
            UserMessage person = null;
            if (dt != null)
            {
                personmsg = new List<UserMessage>();
                foreach (DataRow dr in dt.Rows)
                {
                    person = new UserMessage();
                    person.FromName = dr["FromPerson"].ToString();
                    person.ToName = dr["ToPerson"].ToString();
                    person.Subject = dr["Subject"].ToString();
                    person.Message = dr["Message"].ToString();
                    person.CreatedDate = Convert.ToDateTime(dr["CreatedDate"].ToString());

                    personmsg.Add(person);

                }
            }
            return personmsg;

        }
        [OperationContract]
        public byte[] GetImageStream(string filePath)
        {
            byte[] imgbytes = null;
            if (!string.IsNullOrEmpty(filePath))
            {
                FileStream fileread = new FileStream(filePath, FileMode.Open,FileAccess.Read);

                if (fileread != null)
                {
                    imgbytes = new Byte[(int)fileread.Length];
                    fileread.Read(imgbytes, 0, (int)fileread.Length);
                }
                fileread.Close();
            }

            return imgbytes; ;
        }
        public string SaveImageFile(string fileName, Byte[] stream)
        {
            //todo
           string filePath = System.Configuration.ConfigurationManager.AppSettings["photoPath"] + fileName + ".jpg";
            //string urlpath = Request.PhysicalApplicationPath.Replace("yo", "yoimage");
            //filePath = HttpContext.Current.Server.MapPath("~/Images/") + fileName + ".jpg";

            FileStream fileSave = new FileStream(filePath, FileMode.OpenOrCreate,FileAccess.ReadWrite);


            fileSave.Write(stream, 0, (int)stream.Length);

            fileSave.Close();


            return filePath;
        }


        // Add more operations here and mark them with [OperationContract]
    }
}
