﻿
namespace Yo.Web.Services
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Data;
    using System.Data.SqlClient;
    using System.IO;
    using System.Linq;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;


    // TODO: Create methods containing your application logic.
    [EnableClientAccess()]
    public class SearchUserSearchListService : DomainService
    {
        // This is never used but without it RIA Services will complain RegistrationData
        // is not exposed as an entity
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1822:MarkMembersAsStatic"), System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1024:UsePropertiesWhereAppropriate")]
        public IEnumerable<ShowUserDetails> GetUsers(string currentperson, string personname)
        {

            SqlConnection connection = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["OnlineChatDatabase"].ConnectionString);
            SqlCommand command = new SqlCommand();
            SqlParameter paramperson = new SqlParameter("@currentname", currentperson);
            SqlParameter paramfirstperson = new SqlParameter("@personname", personname);


            command.CommandText = "GetSearchPersonList";
            command.CommandType = CommandType.StoredProcedure;
            command.Connection = connection;
            command.Parameters.Add(paramperson);
            command.Parameters.Add(paramfirstperson);

            SqlDataAdapter adapter = new SqlDataAdapter(command);
            DataTable dt = new DataTable();
            adapter.Fill(dt);

            return ConvertDataTableToShowUserDetails(dt);
        }


        private List<ShowUserDetails> ConvertDataTableToShowUserDetails(DataTable dt)
        {
            List<ShowUserDetails> personmsg = null;
            ShowUserDetails person = null;
            if (dt != null)
            {
                personmsg = new List<ShowUserDetails>();
                foreach (DataRow dr in dt.Rows)
                {
                    person = new ShowUserDetails();
                    person.User_Id = dr["User_Id"].ToString();
                    person.User_Name = dr["User_Name"].ToString();
                    person.First_Name = dr["First_Name"].ToString();
                    person.Last_Name = dr["Last_Name"].ToString();
                    person.User_Active = dr["User_Active"].ToString();
                    person.User_Country = dr["User_Country"].ToString();
                    person.User_States = dr["User_States"].ToString();
                    if (!string.IsNullOrEmpty(dr["IsExist"].ToString()))
                    {
                        person.IsExist = Convert.ToInt32(dr["IsExist"].ToString());
                    }
                    person.Image_Url = dr["Image_Url"].ToString();
                    person.ImageSource = GetImageStream(dr["Image_Url"].ToString());

                    personmsg.Add(person);

                }
            }
            return personmsg;

        }

        private byte[] GetImageStream(string filePath)
        {
            byte[] imgbytes = null;
            if (!string.IsNullOrEmpty(filePath))
            {
                if (File.Exists(filePath))
                {
                    FileStream fileread = new FileStream(filePath, FileMode.Open,FileAccess.Read);

                    if (fileread != null)
                    {
                        imgbytes = new Byte[(int)fileread.Length];
                        fileread.Read(imgbytes, 0, (int)fileread.Length);
                    }
                    fileread.Close();
                }
            }

            return imgbytes; ;
        }

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1822:MarkMembersAsStatic")]
        [Insert]
        public void AddUser(ShowUserDetails user)
        {
            throw new NotImplementedException();
        }

        [Update]
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1822:MarkMembersAsStatic"), System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1024:UsePropertiesWhereAppropriate")]
        public void UpdateUser(ShowUserDetails user)
        {
            throw new NotImplementedException();
        }
    }
}


